﻿@using Kendo.Mvc.UI
@model IEnumerable<Iglo.World.ViewModels.ArheaderViewModel>
@{
    ViewBag.Title = "AR";
    ViewBag.Controller = "AR";


}

<h3>AR</h3>
<div class="navbar navbar-inverse navbar-fixed-top border-bottom border-danger" style="padding: 0; margin: 0.5rem 0rem;">
</div>
<div class="grid-add-btn" style="margin:1rem 0">
    <a href="javascript:;" class="btn btn-primary" id="btnAddNew"><i class="fa fa-plus"></i> Add New</a>
</div>

@(Html.Kendo().Grid(Model).Name("grid").Columns(columns =>
{
    columns.Bound(m => m.InvoiceNum).Title("Invoice No");
    columns.Bound(m => m.InvoiceDate).Title("Invoice Date").Format("{0:dd MMM yyyy}");
    columns.Bound(m => m.HeaderDescription).Title("Description");
    //columns.Bound("").ClientTemplate("<a data-id='#=ID#' href='javascript:;' class='act-btn editRow'>Edit</a> | <a data-id='#=ID#' href='javascript:;' class='act-btn deleteRow'>Delete</a>").Width(150).Title("").Filterable(false);
    //columns.Bound("").ClientTemplate("<a data-id='#=InvoiceNum#' href='javascript:;' class='act-btn deleteRow'>Delete</a>").Width(150).Title("").Filterable(false);
})
        .HtmlAttributes(new { style = "height : 450px;" })
        .Scrollable()
        .Sortable()
        .Filterable()
        .Pageable(pageable => pageable
            .Refresh(true)
            .PageSizes(true)
            .ButtonCount(5))
        .DataSource(dataSource => dataSource
            .Ajax()
            .Read(read => read.Action("List", "AR"))
            .PageSize(20)
        )
)

<div id="addEditWindow"></div>
<div id="addEditWindowDetail"></div>

@section scripts{

    <script>
    var popup = (function (popup) {
        popup.width = 1000;
        popup.height = 400;
        popup.createUrl = "@Url.Action("Create")";
        popup.editUrl = "@Url.Action("Edit")";
        popup.submitUrl = "@Url.Action("Submit")";
        popup.deleteUrl = "@Url.Action("Delete")";
        popup.deleteRowUrl = "@Url.Action("Delete")";
        popup.createTitle = "Add AR Invoice";
        //popup.editTitle = "Edit JobType";

        popup.CreateDetailUrl = "@Url.Action("CreateDetail")";
        popup.CreateDetail = "@Url.Action("CreateDetail")";
        popup.createDetailTitle = "Add Detail AR";
        popup.EditDetailUrl = "@Url.Action("EditDetail")";
        popup.deleteDetailUrl = "@Url.Action("DeleteDetail")";

        return popup;
        })(popup || {});

        popup.getUrl = function () {
            return popup.CreateDetail + "?InvoiceNo=" + $("#HeaderID").val();
        }

        popup.addNewDetailClick = function (e) {
            id = $("#HeaderID").val();
            if (id == "") {
                popup.saveHeaderClick(e);
            } else {
                popup.createDetailUrl = popup.getUrl();
                popup.addNewDetailWindowClick(e);
            }
        };

        popup.saveHeaderClick = function (e) {
            e.preventDefault();
            const validator = $("#addEditForm").kendoValidator(Starbridges.validatorOptions).data("kendoValidator");
            if (validator.validate()) {
                $("#btnAddDetail").disableBtn();
                $.ajax({
                    type: "POST",
                    url: popup.createUrl,
                    data: $("#addEditForm").serialize(),
                    success: function (result) {
                        if (result.Message != null) {
                            if (result.IsSuccess) {
                                //var data = JSON.parse(result.Message);
                                $("#HeaderID").val(result.Message);
                                $("#InvoiceNum").val(result.Message);
                                $("#btnAddDetail").enableBtn();

                                $("#grid").data("kendoGrid").dataSource.read();
                                popup.createDetailUrl = popup.getUrl();

                                popup.addNewDetailWindowClick(e);

                            } else {
                                $("#btnAddDetail").enableBtn();
                                swal({
                                    title: "Something Wrong",
                                    text: result.Message,
                                    type: "error",
                                    html: true
                                });
                            }
                        } else {
                            swal({
                                title: "Something Wrong",
                                text: result.Message,
                                type: "error",
                                html: true
                            });
                        }
                    },
                    error: function (err) {
                        $("#btnAddDetail").enableBtn();
                        swal({
                            title: "Error",
                            text: err.Message,
                            type: "error",
                            html: true
                        });
                    }
                });
            }
        };

        popup.addNewDetailWindowClick = function (e) {
            e.preventDefault();
            $(".k-window-title").html(popup.createDetailTitle);
            $("#addEditWindowDetail")
                .data("kendoWindow")
                .refresh({
                    url: popup.createDetailUrl
                })
                .center()
                .open();
            event = e;
        };


        popup.saveDetailClick = function (e) {
            e.preventDefault();
            const validator = $("#addEditFormDetail").kendoValidator(Starbridges.validatorOptions).data("kendoValidator");
            if (validator.validate()) {
                $("#btnSaveDetailNew").disableBtn();
                $.ajax({
                   
                    type: "POST",
                    url: $("#ArdetailId").val() == 0 || $("#ArdetailId").val() == "" ? popup.CreateDetailUrl : popup.EditDetailUrl,
                    data: $("#addEditFormDetail").serialize(),
                    success: function (result) {
                        if (result.Message != null) {
                            if (result.IsSuccess) {
                                swal(result.Message, "Click ok to proceed!", "success");

                                $("#addEditWindowDetail").data("kendoWindow").close();
                                $("#gridDetail").data("kendoGrid").dataSource.read();
                            } else {
                                $("#btnSaveDetail").enableBtn();
                                swal({
                                    title: "Something Wrong",
                                    text: result.Message,
                                    type: "error",
                                    html: true
                                });
                            }
                        }
                    },
                    error: function (err) {
                        $("#btnSaveDetail").enableBtn();
                        swal({
                            title: "Error",
                            text: err.Message,
                            type: "error",
                            html: true
                        });
                    }
                });
            }
        };

        popup.deleteRowDetailClick = function (e) {
            e.preventDefault();
            var text = "";
            swal({
                title: "Are you sure to delete this data?",
                text: text,
                showCancelButton: true,
                confirmButtonColor: "#c0392b",
                confirmButtonText: "DELETE",
                imageUrl: "/Images/delete.png",
                closeOnConfirm: false,
                showLoaderOnConfirm: true,
                html: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    e.preventDefault();
                    $.ajax({
                        type: "POST",
                        url: popup.deleteDetailUrl,
                        data: {
                            id: $(e.target).closest("a").attr("data-id")
                        },
                        traditional: true,
                        success: function (result) {
                            if (result.Message != null) {
                                if (result.IsSuccess) {
                                    $("#gridDetail").data("kendoGrid").dataSource.read();

                                    swal(result.Message, "Click ok to proceed", "success");
                                } else {
                                    swal({
                                        title: "Something Wrong",
                                        text: result.Message,
                                        type: "error"
                                    });
                                }
                            }
                        },
                        error: function (result) {
                            swal({
                                title: "Error",
                                text: result.Message,
                                type: "error"
                            });
                        }
                    });
                }
            });
        };

        popup.btnSaveHeaderClick = function (e) {
            e.preventDefault();
            const validator = $("#addEditForm").kendoValidator(Starbridges.validatorOptions).data("kendoValidator");
            if (validator.validate()) {
                $("#btnSave").disableBtn();
                $("#btnClose").hide();
                $.ajax({
                    type: "POST",
                    url: popup.editUrl,
                    data: $("#addEditForm").serialize(),
                    success: function (result) {
                        $("#Loading").hide();
                        $("#btnSave").enableBtn();
                        if (result.IsSuccess) {
                            $("#HeaderID").val(result.Message);
                            $("#InvoiceNum").val(result.Message);

                            swal("Saved", "Click ok to proceed!", "success");
                        }
                        else {
                            swal({
                                title: "Something Wrong",
                                text: result.Message,
                                type: "error",
                                html: true
                            });
                        }
                        $("#btnClose").show();
                    },
                    error: function (err) {
                        $("#btnSave").enableBtn();
                        $("#btnClose").show();
                        swal({
                            title: "Error",
                            text: err.Message,
                            type: "error",
                            html: true
                        });
                    }
                });
            }
        };
    </script>
    <script src="~/js/modules/pop-up.js"></script>

}